/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ACCESS = 258,
     ALIAS = 259,
     ARRAY = 260,
     AT = 261,
     CASE = 262,
     CONSTANT = 263,
     BEGIN_TOK = 264,
     ELSE = 265,
     ELSIF = 266,
     END = 267,
     FOR = 268,
     FUNCTION = 269,
     GOTO = 270,
     IF = 271,
     IN = 272,
     INOUT = 273,
     IS = 274,
     LOOP = 275,
     MODULE = 276,
     NULL_TOK = 277,
     OF = 278,
     OTHERS = 279,
     OUT = 280,
     PRAGMA = 281,
     PROCEDURE = 282,
     PUBLIC = 283,
     RECORD = 284,
     RETURN = 285,
     THEN = 286,
     TO = 287,
     TYPE = 288,
     VOLATILE = 289,
     WHEN = 290,
     WHILE = 291,
     WITH = 292,
     ASM = 293,
     ATTRIB = 294,
     IDENT = 295,
     NUMBER = 296,
     STRING = 297,
     LSH = 298,
     RSH = 299,
     ARROW = 300,
     GREATER_EQUAL = 301,
     LESS_EQUAL = 302,
     EQUAL = 303,
     NOT_EQUAL = 304,
     LOGICAL_AND = 305,
     LOGICAL_OR = 306
   };
#endif
#define ACCESS 258
#define ALIAS 259
#define ARRAY 260
#define AT 261
#define CASE 262
#define CONSTANT 263
#define BEGIN_TOK 264
#define ELSE 265
#define ELSIF 266
#define END 267
#define FOR 268
#define FUNCTION 269
#define GOTO 270
#define IF 271
#define IN 272
#define INOUT 273
#define IS 274
#define LOOP 275
#define MODULE 276
#define NULL_TOK 277
#define OF 278
#define OTHERS 279
#define OUT 280
#define PRAGMA 281
#define PROCEDURE 282
#define PUBLIC 283
#define RECORD 284
#define RETURN 285
#define THEN 286
#define TO 287
#define TYPE 288
#define VOLATILE 289
#define WHEN 290
#define WHILE 291
#define WITH 292
#define ASM 293
#define ATTRIB 294
#define IDENT 295
#define NUMBER 296
#define STRING 297
#define LSH 298
#define RSH 299
#define ARROW 300
#define GREATER_EQUAL 301
#define LESS_EQUAL 302
#define EQUAL 303
#define NOT_EQUAL 304
#define LOGICAL_AND 305
#define LOGICAL_OR 306




/* Copy the first part of user declarations.  */
#line 1 "parse.y"

/* Parser
   Copyright (C) 2003, 2004, 2005
   Craig Franklin

This file is part of gputils.

gputils is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

gputils is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with gputils; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#include "stdhdr.h"

#include "libgputils.h"
#include "gpal.h"
#include "scan.h"
#include "analyze.h"

#define YYERROR_VERBOSE

int yylex(void);

static gp_linked_list *case_stack = NULL;
static tree *case_ident = NULL;
static tree *last_node = NULL;

void
yyerror(char *message)
{

  gp_num_errors++;

  if (gp_quiet)
    return;

  assert(message != NULL);
  
  if (state.src) {
    printf("%s:%d:%s\n", state.src->name, state.src->line_number, message);
  } else {
    printf("error: %s\n", message);
  }

  return;
}

static void
add_entity(tree *node)
{
  struct symbol *sym;
  tree *def;

  if (FILE_TYPE(node) == source_module) {
    sym = get_symbol(state.modules, FILE_NAME(node));
  } else if (FILE_TYPE(node) == source_with) {
    sym = get_symbol(state.publics, FILE_NAME(node));
  } else {
    assert(0);
  }
  
  if (sym == NULL) {
    if (state.root == NULL) {
      state.root = node;
      last_node = node;
    } else {
      node->prev = last_node;
      last_node->next = node;
      last_node = node;
    }
    if (FILE_TYPE(node) == source_module) {
      sym = add_symbol(state.modules, FILE_NAME(node));
    } else if (FILE_TYPE(node) == source_with) {
      sym = add_symbol(state.publics, FILE_NAME(node));
    }
    if (sym) {
      annotate_symbol(sym, node);
    } else {
      analyze_error(node, "unknown public or module %s", FILE_NAME(node));
    }
  } else {
    def = get_symbol_annotation(sym);
    analyze_error(node,
                  "redefinition of %s,\n\talso defined in %s:%i:",
                  FILE_NAME(node),
                  get_file_name(def->file_id),
                  def->line_number);
  }

  return;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 107 "parse.y"
typedef union YYSTYPE {
  int i;
  struct {
    char *s;
    enum attrib_type t;
  } a;
  struct {
    tree *start;
    tree *end;
  } r;
  char *s;
  tree *t;
  enum node_dir d;
  enum node_op o;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 298 "parse.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 310 "parse.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   309

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  47
/* YYNRULES -- Number of rules. */
#define YYNRULES  130
/* YYNRULES -- Number of states. */
#define YYNSTATES  274

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   306

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      67,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    65,     2,     2,     2,    64,    54,     2,
      68,    69,    62,    60,    70,    61,     2,    63,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    44,    43,
      52,    59,    53,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    71,     2,    72,    56,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    55,     2,    66,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    45,    46,
      47,    48,    49,    50,    51,    57,    58
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,    11,    19,    27,    28,    30,
      32,    35,    39,    41,    48,    56,    64,    68,    73,    79,
      83,    91,    97,   105,   114,   115,   118,   119,   122,   127,
     133,   136,   142,   149,   158,   166,   175,   176,   178,   180,
     183,   188,   190,   194,   199,   201,   205,   210,   212,   214,
     216,   222,   223,   225,   227,   230,   233,   236,   240,   244,
     247,   255,   264,   265,   274,   280,   284,   286,   289,   294,
     300,   303,   308,   314,   319,   321,   325,   327,   329,   335,
     339,   341,   343,   347,   349,   351,   355,   357,   359,   363,
     365,   367,   369,   373,   375,   377,   379,   381,   385,   387,
     389,   391,   393,   395,   397,   399,   403,   405,   407,   409,
     413,   415,   417,   419,   423,   425,   427,   429,   431,   434,
     436,   438,   440,   442,   444,   446,   448,   453,   457,   462,
     464
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      74,     0,    -1,    -1,    74,    75,    -1,    74,     1,    67,
      -1,    21,    40,    19,    76,    12,    21,    43,    -1,    28,
      40,    19,    76,    12,    28,    43,    -1,    -1,    77,    -1,
      78,    -1,    78,    77,    -1,    37,    40,    43,    -1,    82,
      -1,    40,    44,    40,    79,    80,    43,    -1,    40,    44,
      34,    40,    79,    80,    43,    -1,    40,    44,     8,    40,
      59,   102,    43,    -1,    26,   102,    43,    -1,     4,    40,
     102,    43,    -1,    27,    86,    90,    27,    43,    -1,    27,
      86,    43,    -1,    14,    86,    30,    40,    90,    14,    43,
      -1,    14,    86,    30,    40,    43,    -1,    16,   102,    31,
      76,    12,    16,    43,    -1,    16,   102,    31,    76,    81,
      12,    16,    43,    -1,    -1,    59,   102,    -1,    -1,     6,
     102,    -1,    11,   102,    31,    76,    -1,    11,   102,    31,
      76,    81,    -1,    10,    76,    -1,    33,    40,    19,    40,
      43,    -1,    33,    40,    19,     3,    40,    43,    -1,    33,
      40,    19,     5,   100,    23,    40,    43,    -1,    33,    40,
      19,    68,   101,    69,    43,    -1,    33,    40,    19,    29,
      83,    12,    29,    43,    -1,    -1,    84,    -1,    85,    -1,
      85,    84,    -1,    40,    44,    40,    43,    -1,    40,    -1,
      40,    68,    69,    -1,    40,    68,    87,    69,    -1,    88,
      -1,    88,    70,    87,    -1,    40,    44,    89,    40,    -1,
      17,    -1,    18,    -1,    25,    -1,    19,    76,     9,    91,
      12,    -1,    -1,    92,    -1,    93,    -1,    93,    92,    -1,
      22,    43,    -1,    40,    44,    -1,    15,    40,    43,    -1,
      30,   102,    43,    -1,    38,    43,    -1,    16,   102,    31,
      91,    12,    16,    43,    -1,    16,   102,    31,    91,    95,
      12,    16,    43,    -1,    -1,     7,    40,    94,    19,    96,
      12,     7,    43,    -1,    13,    40,    17,   100,    99,    -1,
      36,   102,    99,    -1,    99,    -1,   102,    43,    -1,    11,
     102,    31,    91,    -1,    11,   102,    31,    91,    95,    -1,
      10,    91,    -1,    35,    97,    47,    91,    -1,    35,    97,
      47,    91,    96,    -1,    35,    24,    47,    91,    -1,    98,
      -1,    98,    55,    97,    -1,    40,    -1,    41,    -1,    20,
      91,    12,    20,    43,    -1,   102,    32,   102,    -1,    39,
      -1,   102,    -1,   102,    70,   101,    -1,   103,    -1,   105,
      -1,   103,   104,   105,    -1,    59,    -1,   107,    -1,   105,
     106,   107,    -1,    57,    -1,    58,    -1,   109,    -1,   107,
     108,   109,    -1,    54,    -1,    55,    -1,    56,    -1,   111,
      -1,   109,   110,   111,    -1,    52,    -1,    53,    -1,    50,
      -1,    51,    -1,    48,    -1,    49,    -1,   113,    -1,   111,
     112,   113,    -1,    45,    -1,    46,    -1,   115,    -1,   113,
     114,   115,    -1,    60,    -1,    61,    -1,   117,    -1,   115,
     116,   117,    -1,    62,    -1,    63,    -1,    64,    -1,   119,
      -1,   118,   119,    -1,    61,    -1,    65,    -1,    66,    -1,
      60,    -1,    42,    -1,    40,    -1,    39,    -1,    40,    71,
     102,    72,    -1,    40,    68,    69,    -1,    40,    68,   101,
      69,    -1,    41,    -1,    68,   102,    69,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   244,   244,   247,   249,   253,   258,   266,   270,   277,
     282,   289,   294,   299,   304,   309,   314,   319,   324,   329,
     334,   339,   344,   349,   357,   361,   369,   373,   380,   386,
     391,   399,   405,   411,   417,   423,   432,   436,   443,   448,
     455,   462,   467,   472,   479,   484,   491,   498,   499,   500,
     504,   512,   516,   523,   528,   535,   540,   545,   550,   555,
     560,   565,   571,   570,   591,   610,   615,   620,   627,   633,
     638,   646,   652,   657,   665,   670,   677,   682,   689,   696,
     702,   715,   720,   726,   729,   731,   737,   740,   742,   748,
     749,   752,   754,   760,   761,   762,   765,   767,   773,   774,
     775,   776,   777,   778,   781,   783,   789,   790,   793,   795,
     801,   802,   805,   807,   813,   814,   815,   818,   820,   826,
     827,   828,   829,   832,   837,   842,   847,   852,   858,   864,
     869
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "\"access\"", "\"alias\"", "\"array\"",
  "\"at\"", "\"case\"", "\"constant\"", "\"begin\"", "\"else\"",
  "\"elsif\"", "\"end\"", "\"for\"", "\"function\"", "\"goto\"", "\"if\"",
  "\"in\"", "\"inout\"", "\"is\"", "\"loop\"", "\"module\"", "\"null\"",
  "\"of\"", "\"others\"", "\"out\"", "\"pragma\"", "\"procedure\"",
  "\"public\"", "\"record\"", "\"return\"", "\"then\"", "\"to\"",
  "\"type\"", "\"volatile\"", "\"when\"", "\"while\"", "\"with\"",
  "\"asm\"", "\"attribute\"", "\"symbol\"", "\"number\"", "\"string\"",
  "';'", "':'", "\"<<\"", "\">>\"", "\"=>\"", "\">=\"", "\"<=\"", "\"==\"",
  "\"!=\"", "'<'", "'>'", "'&'", "'|'", "'^'", "\"&&\"", "\"||\"", "'='",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'~'", "'\\n'", "'('", "')'",
  "','", "'['", "']'", "$accept", "program", "entity", "element_start",
  "element_list", "element", "var_value", "var_location", "element_cond",
  "type", "record_start", "record_list", "simple_decl", "head", "arg_list",
  "arg", "arg_direction", "body", "statement_start", "statement_block",
  "statement", "@1", "if_body", "case_body", "case_element_list",
  "case_element", "loop_statement", "range", "parameter_list", "expr",
  "e8", "e8op", "e7", "e7op", "e6", "e6op", "e5", "e5op", "e4", "e4op",
  "e3", "e3op", "e2", "e2op", "e1", "e1op", "e0", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    59,    58,   298,   299,   300,   301,   302,
     303,   304,    60,    62,    38,   124,    94,   305,   306,    61,
      43,    45,    42,    47,    37,    33,   126,    10,    40,    41,
      44,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    74,    74,    74,    75,    75,    76,    76,    77,
      77,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    78,    78,    78,    79,    79,    80,    80,    81,    81,
      81,    82,    82,    82,    82,    82,    83,    83,    84,    84,
      85,    86,    86,    86,    87,    87,    88,    89,    89,    89,
      90,    91,    91,    92,    92,    93,    93,    93,    93,    93,
      93,    93,    94,    93,    93,    93,    93,    93,    95,    95,
      95,    96,    96,    96,    97,    97,    98,    98,    99,   100,
     100,   101,   101,   102,   103,   103,   104,   105,   105,   106,
     106,   107,   107,   108,   108,   108,   109,   109,   110,   110,
     110,   110,   110,   110,   111,   111,   112,   112,   113,   113,
     114,   114,   115,   115,   116,   116,   116,   117,   117,   118,
     118,   118,   118,   119,   119,   119,   119,   119,   119,   119,
     119
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     3,     7,     7,     0,     1,     1,
       2,     3,     1,     6,     7,     7,     3,     4,     5,     3,
       7,     5,     7,     8,     0,     2,     0,     2,     4,     5,
       2,     5,     6,     8,     7,     8,     0,     1,     1,     2,
       4,     1,     3,     4,     1,     3,     4,     1,     1,     1,
       5,     0,     1,     1,     2,     2,     2,     3,     3,     2,
       7,     8,     0,     8,     5,     3,     1,     2,     4,     5,
       2,     4,     5,     4,     1,     3,     1,     1,     5,     3,
       1,     1,     3,     1,     1,     3,     1,     1,     3,     1,
       1,     1,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     1,     1,     3,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     4,     3,     4,     1,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,     0,     0,     0,     3,     4,     0,     0,
       7,     7,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     8,     9,    12,     0,     0,    41,     0,   125,   124,
     129,   123,   122,   119,   120,   121,     0,     0,    83,    84,
      87,    91,    96,   104,   108,   112,     0,   117,     0,     0,
       0,     0,     0,     0,    10,     0,     0,     0,     0,     0,
       0,     0,     7,    86,     0,    89,    90,     0,    93,    94,
      95,     0,   102,   103,   100,   101,    98,    99,     0,   106,
     107,     0,   110,   111,     0,   114,   115,   116,     0,   118,
      16,     7,    19,     0,     0,    11,     0,     0,    24,     0,
       0,    17,     0,    42,     0,    44,     0,   127,     0,    81,
       0,   130,     0,    85,    88,    92,    97,   105,   109,   113,
       0,     0,     0,     0,    36,     0,     0,     0,    24,     0,
      26,     5,     6,     0,    43,     0,    21,     0,   128,     0,
     126,     7,     0,     0,     0,    51,    18,     0,   125,     0,
       0,     0,     0,    37,    38,    31,     0,     0,    26,    25,
       0,     0,    47,    48,    49,     0,    45,     0,    82,    30,
       0,     0,     0,     0,     0,     0,     0,    51,     0,     0,
       0,     0,   124,     0,    52,    53,    66,     0,    32,     0,
       0,     0,     0,    39,     0,     0,     0,    27,    13,    46,
      20,     7,    22,     0,    62,     0,     0,     0,     0,    55,
       0,     0,    59,    56,    50,    54,    67,     0,    79,     0,
       0,    34,    15,    14,    28,    23,     0,     0,    57,    51,
       0,    58,    65,    33,    40,    35,    29,     0,     0,     0,
       0,     0,     0,    64,    51,     0,     0,     0,    78,     0,
      76,    77,     0,    74,     0,    70,     0,     0,     0,    51,
      51,     0,     0,    51,    60,     0,    73,    71,    75,    63,
      68,    61,    72,    69
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     6,    20,    21,    22,   130,   161,   144,    23,
     152,   153,   154,    27,   104,   105,   165,    93,   183,   184,
     185,   226,   247,   242,   252,   253,   186,   149,   108,   187,
      38,    64,    39,    67,    40,    71,    41,    78,    42,    81,
      43,    84,    44,    88,    45,    46,    47
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -195
static const short yypact[] =
{
    -195,    39,  -195,   -46,   -17,    19,  -195,  -195,    44,    49,
      84,    84,    21,    31,   -32,   -32,    31,    33,    47,    35,
      87,  -195,    84,  -195,    91,   -32,    48,    78,  -195,   -36,
    -195,  -195,  -195,  -195,  -195,  -195,   -32,   102,    88,    26,
      51,    42,    68,    62,    56,  -195,   -26,  -195,   110,     5,
     133,   111,    -3,   136,  -195,   130,   124,   -22,   131,    95,
     -32,    90,    84,  -195,   -32,  -195,  -195,   -32,  -195,  -195,
    -195,   -32,  -195,  -195,  -195,  -195,  -195,  -195,   -32,  -195,
    -195,   -32,  -195,  -195,   -32,  -195,  -195,  -195,   -32,  -195,
    -195,    84,  -195,   141,     1,  -195,   132,   138,   114,   137,
     139,  -195,   135,  -195,   112,   113,     7,  -195,   115,   117,
     118,  -195,   119,    26,    51,    42,    68,    62,    56,  -195,
     176,   143,   148,   109,   149,   150,   -32,   140,   114,   -32,
     185,  -195,  -195,     2,  -195,   154,  -195,   181,  -195,   -32,
    -195,    84,   -32,   180,   186,    36,  -195,   157,    34,   174,
     169,   158,   191,  -195,   149,  -195,   142,   -32,   185,  -195,
     -32,   161,  -195,  -195,  -195,   165,  -195,   163,  -195,  -195,
     177,   164,   193,   170,   172,   175,   -32,    36,   171,   -32,
     -32,   173,    -6,   205,  -195,    36,  -195,   178,  -195,   179,
     -32,   182,   189,  -195,   183,   184,   187,  -195,  -195,  -195,
    -195,    84,  -195,   190,  -195,   203,   192,   194,   211,  -195,
     195,   204,  -195,  -195,  -195,  -195,  -195,   196,  -195,   197,
     198,  -195,  -195,  -195,   116,  -195,   209,   109,  -195,    36,
     212,  -195,  -195,  -195,  -195,  -195,  -195,   199,   204,   128,
     200,    40,   217,  -195,    36,   -32,   220,   225,  -195,   201,
    -195,  -195,   202,   206,   235,  -195,   213,   207,   229,    36,
      36,   101,   208,    36,  -195,   210,  -195,   199,  -195,  -195,
     134,  -195,  -195,  -195
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -195,  -195,  -195,    -9,   224,  -195,   126,    89,    28,  -195,
    -195,   103,  -195,   239,   121,  -195,  -195,   152,  -174,    74,
    -195,  -195,   -10,    -5,     3,  -195,  -194,    38,  -114,   -14,
    -195,  -195,   214,  -195,   215,  -195,   216,  -195,   188,  -195,
     218,  -195,   219,  -195,   221,  -195,   222
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -81
static const short yytable[] =
{
      37,    48,    24,   208,   122,    96,   123,    28,    29,    30,
      31,    56,   156,    28,    29,    30,    31,   232,   102,   162,
     163,     7,    61,     8,    91,   168,    91,   164,    32,    33,
     124,    97,    59,    34,    35,    60,    36,    98,   213,     2,
       3,   125,    36,   173,   243,   109,   110,   103,    92,   174,
     136,   175,   176,   112,   -80,   239,   177,   -80,   178,     9,
       4,    25,    59,    10,   249,    60,   179,     5,    11,   126,
     255,    26,   180,    50,   181,    28,   182,    30,    31,    52,
     250,   251,   120,    65,    66,   266,   267,    51,    12,   270,
      72,    73,    74,    75,    76,    77,    32,    33,    13,    53,
      14,    34,    35,    55,    36,    68,    69,    70,    58,   150,
      15,    16,   109,    79,    80,   159,    57,    17,    85,    86,
      87,    18,    82,    83,    19,   109,   141,   142,   170,   141,
     142,   143,   169,    62,    28,    29,    30,    31,   244,   245,
     246,   250,   251,   195,   244,   245,   197,    63,   148,    29,
      30,    31,    94,    90,    95,    32,    33,    99,   100,   111,
      34,    35,   207,    36,   107,   210,   211,   101,   121,    32,
      33,   106,   127,   129,    34,    35,   218,    36,   128,   133,
     131,   134,   132,   135,   138,   145,   146,   139,   147,   151,
     140,   160,   224,   155,   102,   167,   171,   189,   172,   157,
     188,   190,   191,   192,   198,   199,   200,   202,   201,   203,
     204,   194,   205,   150,   209,   206,   212,   214,   220,   217,
     227,   216,   219,   230,   177,   229,   221,   222,   237,   254,
     223,   256,   240,   225,   241,   228,   257,   258,   231,   233,
     234,   235,   262,   248,   263,   265,    54,   196,   259,   260,
     264,   269,   236,   271,   158,    49,   166,   193,   137,   215,
     273,   261,   272,     0,   268,   238,   116,     0,    89,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   113,     0,
       0,     0,   114,     0,     0,     0,     0,   115,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
       0,     0,     0,   118,     0,     0,     0,     0,     0,   119
};

static const short yycheck[] =
{
      14,    15,    11,   177,     3,     8,     5,    39,    40,    41,
      42,    25,   126,    39,    40,    41,    42,   211,    40,    17,
      18,    67,    36,    40,    19,   139,    19,    25,    60,    61,
      29,    34,    68,    65,    66,    71,    68,    40,    44,     0,
       1,    40,    68,     7,   238,    59,    60,    69,    43,    13,
      43,    15,    16,    62,    20,   229,    20,    23,    22,    40,
      21,    40,    68,    19,    24,    71,    30,    28,    19,    68,
     244,    40,    36,    40,    38,    39,    40,    41,    42,    44,
      40,    41,    91,    57,    58,   259,   260,    40,     4,   263,
      48,    49,    50,    51,    52,    53,    60,    61,    14,    12,
      16,    65,    66,    12,    68,    54,    55,    56,    30,   123,
      26,    27,   126,    45,    46,   129,    68,    33,    62,    63,
      64,    37,    60,    61,    40,   139,    10,    11,   142,    10,
      11,    12,   141,    31,    39,    40,    41,    42,    10,    11,
      12,    40,    41,   157,    10,    11,   160,    59,    39,    40,
      41,    42,    19,    43,    43,    60,    61,    21,    28,    69,
      65,    66,   176,    68,    69,   179,   180,    43,    27,    60,
      61,    40,    40,    59,    65,    66,   190,    68,    40,    44,
      43,    69,    43,    70,    69,     9,    43,    70,    40,    40,
      72,     6,   201,    43,    40,    14,    16,    23,    12,    59,
      43,    32,    44,    12,    43,    40,    43,    43,    31,    16,
      40,    69,    40,   227,    43,    40,    43,    12,    29,    40,
      17,    43,    40,    12,    20,    31,    43,    43,    19,    12,
      43,   245,    20,    43,    35,    43,    16,    12,    43,    43,
      43,    43,     7,    43,    31,    16,    22,   158,    47,    47,
      43,    43,   224,    43,   128,    16,   135,   154,   106,   185,
     270,    55,   267,    -1,   261,   227,    78,    -1,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    -1,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
      -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,    88
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    74,     0,     1,    21,    28,    75,    67,    40,    40,
      19,    19,     4,    14,    16,    26,    27,    33,    37,    40,
      76,    77,    78,    82,    76,    40,    40,    86,    39,    40,
      41,    42,    60,    61,    65,    66,    68,   102,   103,   105,
     107,   109,   111,   113,   115,   117,   118,   119,   102,    86,
      40,    40,    44,    12,    77,    12,   102,    68,    30,    68,
      71,   102,    31,    59,   104,    57,    58,   106,    54,    55,
      56,   108,    48,    49,    50,    51,    52,    53,   110,    45,
      46,   112,    60,    61,   114,    62,    63,    64,   116,   119,
      43,    19,    43,    90,    19,    43,     8,    34,    40,    21,
      28,    43,    40,    69,    87,    88,    40,    69,   101,   102,
     102,    69,    76,   105,   107,   109,   111,   113,   115,   117,
      76,    27,     3,     5,    29,    40,    68,    40,    40,    59,
      79,    43,    43,    44,    69,    70,    43,    90,    69,    70,
      72,    10,    11,    12,    81,     9,    43,    40,    39,   100,
     102,    40,    83,    84,    85,    43,   101,    59,    79,   102,
       6,    80,    17,    18,    25,    89,    87,    14,   101,    76,
     102,    16,    12,     7,    13,    15,    16,    20,    22,    30,
      36,    38,    40,    91,    92,    93,    99,   102,    43,    23,
      32,    44,    12,    84,    69,   102,    80,   102,    43,    40,
      43,    31,    43,    16,    40,    40,    40,   102,    91,    43,
     102,   102,    43,    44,    12,    92,    43,    40,   102,    40,
      29,    43,    43,    43,    76,    43,    94,    17,    43,    31,
      12,    43,    99,    43,    43,    43,    81,    19,   100,    91,
      20,    35,    96,    99,    10,    11,    12,    95,    43,    24,
      40,    41,    97,    98,    12,    91,   102,    16,    12,    47,
      47,    55,     7,    31,    43,    16,    91,    91,    97,    43,
      91,    43,    96,    95
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 254 "parse.y"
    {
	  add_entity(mk_file(yyvsp[-3].t, yyvsp[-5].s, source_module));
	}
    break;

  case 6:
#line 259 "parse.y"
    {
	  add_entity(mk_file(yyvsp[-3].t, yyvsp[-5].s, source_with));
	}
    break;

  case 7:
#line 266 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 8:
#line 271 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 9:
#line 278 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 10:
#line 283 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 11:
#line 290 "parse.y"
    {
	  yyval.t = mk_with(yyvsp[-1].s);
	}
    break;

  case 12:
#line 295 "parse.y"
    {
	  yyval.t = yyvsp[0].t;
        }
    break;

  case 13:
#line 300 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-5].s, false, false, yyvsp[-3].s, yyvsp[-2].t, yyvsp[-1].t);
        }
    break;

  case 14:
#line 305 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-6].s, true, false, yyvsp[-3].s, yyvsp[-2].t, yyvsp[-1].t);
        }
    break;

  case 15:
#line 310 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-6].s, false, true, yyvsp[-3].s, yyvsp[-1].t, NULL);
        }
    break;

  case 16:
#line 315 "parse.y"
    {
	  yyval.t = mk_pragma(yyvsp[-1].t);
	}
    break;

  case 17:
#line 320 "parse.y"
    {
	  yyval.t = mk_alias(yyvsp[-2].s, yyvsp[-1].t);
        }
    break;

  case 18:
#line 325 "parse.y"
    { 
	  yyval.t = mk_subprogram(yyvsp[-3].t, NULL, yyvsp[-2].t);
     	}
    break;

  case 19:
#line 330 "parse.y"
    { 
	  yyval.t = mk_subprogram(yyvsp[-1].t, NULL, NULL);
	}
    break;

  case 20:
#line 335 "parse.y"
    { 
	  yyval.t = mk_subprogram(yyvsp[-5].t, yyvsp[-3].s, yyvsp[-2].t);
	}
    break;

  case 21:
#line 340 "parse.y"
    { 
	  yyval.t = mk_subprogram(yyvsp[-3].t, yyvsp[-1].s, NULL);
	}
    break;

  case 22:
#line 345 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-5].t, yyvsp[-3].t, NULL);
	}
    break;

  case 23:
#line 350 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-6].t, yyvsp[-4].t, yyvsp[-3].t);
	}
    break;

  case 24:
#line 357 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 25:
#line 362 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 26:
#line 369 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 27:
#line 374 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 28:
#line 381 "parse.y"
    {
	  /* last statement is elsif */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 29:
#line 387 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 30:
#line 392 "parse.y"
    {
	  /* last statement is else */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 31:
#line 400 "parse.y"
    {
	  /* type alias */
	  yyval.t = mk_type(yyvsp[-3].s, false, NULL, NULL, NULL, yyvsp[-1].s);
        }
    break;

  case 32:
#line 406 "parse.y"
    {
	  /* access type */
	  yyval.t = mk_type(yyvsp[-4].s, true, NULL, NULL, NULL, yyvsp[-1].s);
        }
    break;

  case 33:
#line 412 "parse.y"
    {
	  /* array */
	  yyval.t = mk_type(yyvsp[-6].s, false, yyvsp[-3].r.start, yyvsp[-3].r.end, NULL, yyvsp[-1].s);
        }
    break;

  case 34:
#line 418 "parse.y"
    {
	  /* enumerated type */
	  yyval.t = mk_type(yyvsp[-5].s, false, NULL, NULL, yyvsp[-2].t, NULL);
        }
    break;

  case 35:
#line 424 "parse.y"
    {
	  /* record definition */
	  yyval.t = mk_record(yyvsp[-6].s, yyvsp[-3].t);
        }
    break;

  case 36:
#line 432 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 37:
#line 437 "parse.y"
    {
          yyval.t = yyvsp[0].t;
	}
    break;

  case 38:
#line 444 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 39:
#line 449 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 40:
#line 456 "parse.y"
    { 
	  yyval.t = mk_decl(yyvsp[-3].s, false, false, yyvsp[-1].s, NULL, NULL);
        }
    break;

  case 41:
#line 463 "parse.y"
    {
 	  yyval.t = mk_head(yyvsp[0].s, NULL);
     	}
    break;

  case 42:
#line 468 "parse.y"
    {
 	  yyval.t = mk_head(yyvsp[-2].s, NULL);
     	}
    break;

  case 43:
#line 473 "parse.y"
    {
 	  yyval.t = mk_head(yyvsp[-3].s, yyvsp[-1].t);
     	}
    break;

  case 44:
#line 480 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 45:
#line 485 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 46:
#line 492 "parse.y"
    {	  
	  yyval.t = mk_arg(yyvsp[-3].s, yyvsp[-1].d, yyvsp[0].s);
        }
    break;

  case 47:
#line 498 "parse.y"
    { yyval.d = dir_in; }
    break;

  case 48:
#line 499 "parse.y"
    { yyval.d = dir_inout; }
    break;

  case 49:
#line 500 "parse.y"
    { yyval.d = dir_out; }
    break;

  case 50:
#line 505 "parse.y"
    {
	  yyval.t = mk_body(yyvsp[-3].t, yyvsp[-1].t);
	}
    break;

  case 51:
#line 512 "parse.y"
    {
	  yyval.t = NULL;
	}
    break;

  case 52:
#line 517 "parse.y"
    {
	  yyval.t = yyvsp[0].t;
	}
    break;

  case 53:
#line 524 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 54:
#line 529 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 55:
#line 536 "parse.y"
    {
	  yyval.t = mk_assembly(strdup("  nop"));
	}
    break;

  case 56:
#line 541 "parse.y"
    {
	  yyval.t = mk_label(yyvsp[-1].s);
	}
    break;

  case 57:
#line 546 "parse.y"
    {
	  yyval.t = mk_goto(yyvsp[-1].s);
	}
    break;

  case 58:
#line 551 "parse.y"
    {
	  yyval.t = mk_return(yyvsp[-1].t);
	}
    break;

  case 59:
#line 556 "parse.y"
    {
	  yyval.t = mk_assembly(yyvsp[-1].s);
	}
    break;

  case 60:
#line 561 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-5].t, yyvsp[-3].t, NULL);
	}
    break;

  case 61:
#line 566 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-6].t, yyvsp[-4].t, yyvsp[-3].t);
	}
    break;

  case 62:
#line 571 "parse.y"
    {
          gp_linked_list *new = gp_list_make();

          new->prev = case_stack;
          case_stack = new;

	  case_ident = mk_symbol(yyvsp[0].s, NULL);
          gp_list_annotate(case_stack, case_ident);
	}
    break;

  case 63:
#line 581 "parse.y"
    {
	  yyval.t = yyvsp[-3].t;
          case_stack = case_stack->prev;
          if (case_stack) {
            case_ident = gp_list_get(case_stack);
          } else {
            case_ident = NULL;
          }
	}
    break;

  case 64:
#line 592 "parse.y"
    {
	  tree *init;
          tree *exit;
          tree *increment;
          
          /* IDENT = range.start; */
          init = mk_binop(op_assign, mk_symbol(yyvsp[-3].s, NULL), yyvsp[-1].r.start);
          
          /* IDENT = IDENT + 1; */
          increment = mk_binop(op_assign, mk_symbol(yyvsp[-3].s, NULL), 
                               mk_binop(op_add, mk_symbol(yyvsp[-3].s, NULL), mk_constant(1)));
          
          /* while (IDENT <= range.end) then loop */
          exit = mk_binop(op_lte, mk_symbol(yyvsp[-3].s, NULL), yyvsp[-1].r.end);

	  yyval.t = mk_loop(init, exit, increment, yyvsp[0].t);
	}
    break;

  case 65:
#line 611 "parse.y"
    {
	  yyval.t= mk_loop(NULL, yyvsp[-1].t, NULL, yyvsp[0].t);	
	}
    break;

  case 66:
#line 616 "parse.y"
    {
	  yyval.t= mk_loop(NULL, NULL, NULL, yyvsp[0].t);
	}
    break;

  case 67:
#line 621 "parse.y"
    {
	  yyval.t = yyvsp[-1].t;
	}
    break;

  case 68:
#line 628 "parse.y"
    {
	  /* last statement is elsif */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 69:
#line 634 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 70:
#line 639 "parse.y"
    {
	  /* last statement is else */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 71:
#line 647 "parse.y"
    {
	  /* last statement is elsif equivalent */
	  yyval.t = mk_cond(yyvsp[-2].t, yyvsp[0].t, NULL);
	}
    break;

  case 72:
#line 653 "parse.y"
    {
	  yyval.t = mk_cond(yyvsp[-3].t, yyvsp[-1].t, yyvsp[0].t);
	}
    break;

  case 73:
#line 658 "parse.y"
    {
	  /* last statement is else equivalent */
	  yyval.t = mk_cond(NULL, yyvsp[0].t, NULL);
	}
    break;

  case 74:
#line 666 "parse.y"
    {
	  yyval.t = mk_binop(op_eq, case_ident, yyvsp[0].t);
	}
    break;

  case 75:
#line 671 "parse.y"
    {
	  yyval.t = mk_binop(op_lor, mk_binop(op_eq, case_ident, yyvsp[-2].t), yyvsp[0].t);
	}
    break;

  case 76:
#line 678 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[0].s, NULL);
        }
    break;

  case 77:
#line 683 "parse.y"
    {
	  yyval.t = mk_constant(yyvsp[0].i);
	}
    break;

  case 78:
#line 690 "parse.y"
    {
	  yyval.t = yyvsp[-3].t;
	}
    break;

  case 79:
#line 697 "parse.y"
    {
	  yyval.r.start = yyvsp[-2].t;
	  yyval.r.end = yyvsp[0].t;
        }
    break;

  case 80:
#line 703 "parse.y"
    {
          if (yyvsp[0].a.t == attrib_range) {
  	    /* transform 'range into 'first and 'last */
            yyval.r.start = mk_attrib(yyvsp[0].a.s, attrib_first);
	    yyval.r.end = mk_attrib(yyvsp[0].a.s, attrib_last);
	  } else {
	    yyerror("either use range attribute or <start> TO <stop>");
          }
        }
    break;

  case 81:
#line 716 "parse.y"
    {
	  yyval.t = node_list(yyvsp[0].t, NULL);
	}
    break;

  case 82:
#line 721 "parse.y"
    {
	  yyval.t = node_list(yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 85:
#line 732 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 86:
#line 737 "parse.y"
    { yyval.o = op_assign; }
    break;

  case 88:
#line 743 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 89:
#line 748 "parse.y"
    { yyval.o = op_land; }
    break;

  case 90:
#line 749 "parse.y"
    { yyval.o = op_lor; }
    break;

  case 92:
#line 755 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 93:
#line 760 "parse.y"
    { yyval.o = op_and; }
    break;

  case 94:
#line 761 "parse.y"
    { yyval.o = op_or; }
    break;

  case 95:
#line 762 "parse.y"
    { yyval.o = op_xor; }
    break;

  case 97:
#line 768 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 98:
#line 773 "parse.y"
    { yyval.o = op_lt; }
    break;

  case 99:
#line 774 "parse.y"
    { yyval.o = op_gt; }
    break;

  case 100:
#line 775 "parse.y"
    { yyval.o = op_eq; }
    break;

  case 101:
#line 776 "parse.y"
    { yyval.o = op_ne; }
    break;

  case 102:
#line 777 "parse.y"
    { yyval.o = op_gte; }
    break;

  case 103:
#line 778 "parse.y"
    { yyval.o = op_lte; }
    break;

  case 105:
#line 784 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 106:
#line 789 "parse.y"
    { yyval.o = op_lsh; }
    break;

  case 107:
#line 790 "parse.y"
    { yyval.o = op_rsh; }
    break;

  case 109:
#line 796 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 110:
#line 801 "parse.y"
    { yyval.o = op_add; }
    break;

  case 111:
#line 802 "parse.y"
    { yyval.o = op_sub; }
    break;

  case 113:
#line 808 "parse.y"
    {
	  yyval.t = mk_binop(yyvsp[-1].o, yyvsp[-2].t, yyvsp[0].t);
	}
    break;

  case 114:
#line 813 "parse.y"
    { yyval.o = op_mult; }
    break;

  case 115:
#line 814 "parse.y"
    { yyval.o = op_div; }
    break;

  case 116:
#line 815 "parse.y"
    { yyval.o = op_mod; }
    break;

  case 118:
#line 821 "parse.y"
    {
	  yyval.t = mk_unop(yyvsp[-1].o, yyvsp[0].t);
	}
    break;

  case 119:
#line 826 "parse.y"
    { yyval.o = op_neg; }
    break;

  case 120:
#line 827 "parse.y"
    { yyval.o = op_not; }
    break;

  case 121:
#line 828 "parse.y"
    { yyval.o = op_com; }
    break;

  case 122:
#line 829 "parse.y"
    { yyval.o = op_add; }
    break;

  case 123:
#line 833 "parse.y"
    {
	  yyval.t = mk_string(yyvsp[0].s);
        }
    break;

  case 124:
#line 838 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[0].s, NULL);
        }
    break;

  case 125:
#line 843 "parse.y"
    {
	  yyval.t = mk_attrib(yyvsp[0].a.s, yyvsp[0].a.t);
        }
    break;

  case 126:
#line 848 "parse.y"
    {
	  yyval.t = mk_symbol(yyvsp[-3].s, yyvsp[-1].t);
        }
    break;

  case 127:
#line 853 "parse.y"
    {
	  /* function or procedure call */
	  yyval.t = mk_call(yyvsp[-2].s, NULL);
	}
    break;

  case 128:
#line 859 "parse.y"
    {
	  /* function or procedure call with arguments */
	  yyval.t = mk_call(yyvsp[-3].s, yyvsp[-1].t);
	}
    break;

  case 129:
#line 865 "parse.y"
    {
	  yyval.t = mk_constant(yyvsp[0].i);
	}
    break;

  case 130:
#line 870 "parse.y"
    {
	  yyval.t = yyvsp[-1].t;
	}
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2267 "parse.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 875 "parse.y"


